Doomsday Engine - Bug #916

[Savegame] Restored state invalid if same addons not present
2010-06-06 13:47 - jimigrey

Status: Closed Start date: 2010-06-06
Priority: Normal % Done: 100%
Assignee: skyjake

Category: Enhancement

Target version: 2.0 — Home Ul & Packages

Description

| play the level a while.. then save. | play some more, but then | die or do something stupid and load the save. | get into the game for
some 10 seconds, and then it gives me this error message:"Z_Free: Attempt to free pointer without ZONEID." If | just play the level
without using save/load, then | don't get the error.

I included a save that has the error happening in about 10 seconds after loading it.

Labels: Data

Related issues:
Related to Feature #1601: Package management In Progress  2014-04-18

Associated revisions

Revision cfc26f69 - 2016-07-06 20:26 - skyjake

Game Save|Resources|libdoomsday: Savegames know which packages were in use
The packages used when a savegame is created are included in the

save metadata. The Home Ul can then match these against the game

to see which saves are usable with which profiles.

IssuelD #916

History

#1 - 2010-06-06 13:47 - danij

Can you tell us any more about the problem? Which version of Doomsday are you running? Has the problem happened since? Are you loading any
other addons?

| can replicate the problem when loading the save attached to this report. It would appear the player weapon state pointer serialised incorrectly, which
when read results in an offset outside the states table (not good).

However I've tried numerous times to reproduce the problem to no avail.

#2 - 2010-08-14 00:35 - danij

This is probably a long shot but were you perhaps using Per Kristian's "smooth weapons mod" when you made this save? This would account for the
bogus player weapon state pointer if you are now attempting to play without it.

#3 - 2010-08-14 00:43 - danij

| decided to put that theory to the test and lo and behold | got it bang on the mark, haha.

) Load both pl2.zip and pk_weapons_dd.wad

) Start any map and save whilst any of the player weapons is in a state not present in the original game,
)

)

Restart, this time loading only pl2.zip

1
2
3
4) Load the broken saved game.

Although clearly this is a case of "don't do that" we really need to do something to prevent users from making such an easy mistake in future.
NB: I'm not setting a group for this report as the same thing occurs in any version of Doomsday.

#4 - 2010-08-14 00:57 - skyjake

Linking this to the savegame format proposal...

#5 - 2012-08-27 20:19 - jimigrey
Attachments:

e http://sourceforge.net/p/deng/bugs/_discuss/thread/a203e43c/42c9/attachment/DoomSav1.dsg

#6 - 2013-10-22 19:40 - skyjake
- Tags set to SaveGame, Resources

- Category set to Enhancement

#7 - 2016-07-05 23:30 - skyjake

- Target version set to 2.0 — Home Ul & Packages

#8 - 2016-07-05 23:32 - skyjake
- Tags changed from SaveGame, Resources to SaveGame, Resources, Packages

- Status changed from New to In Progress

The plan is to include the list of loaded packages in savegame metadata and ensure that the same ones are loaded when the save is loaded.

#9 - 2016-07-06 00:11 - skyjake

- Assignee set to skyjake

#10 - 2016-07-07 12:15 - skyjake
- % Done changed from 0 to 30

#11 - 2016-07-13 12:30 - skyjake
- Status changed from In Progress to Closed

- % Done changed from 30 to 100

The workaround is to check for package compatibility with savegames before loading. This naturally doesn't help old saves, but this will no longer be
a problem in the future.
